package ink.wgink.module.form.service.docnolog;

import ink.wgink.module.form.pojo.dtos.docnolog.DocNoLogDTO;
import ink.wgink.module.form.pojo.pos.docnolog.DocNoLogPO;
import ink.wgink.module.form.pojo.vos.docnolog.DocNoLogVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IDocNoLogService
 * @Description: 文号日志
 * @Author: CodeFactory
 * @Date: 2022-06-29 14:19:06
 * @Version: 3.0
 **/
public interface IDocNoLogService {

    /**
     * 新增文号日志
     *
     * @param docNoLogVO
     * @return
     */
    void save(DocNoLogVO docNoLogVO);

    /**
     * 新增文号日志
     *
     * @param docNoLogVO
     * @return docNoLogId
     */
    String saveReturnId(DocNoLogVO docNoLogVO);

    /**
     * 删除文号日志（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 文号日志详情
     *
     * @param params 参数Map
     * @return
     */
    DocNoLogDTO get(Map<String, Object> params);

    /**
     * 文号日志详情
     *
     * @param docNoLogId
     * @return
     */
    DocNoLogDTO get(String docNoLogId);

    /**
     * 文号日志详情
     *
     * @param params 参数Map
     * @return
     */
    DocNoLogPO getPO(Map<String, Object> params);

    /**
     * 文号日志详情
     *
     * @param docNoLogId
     * @return
     */
    DocNoLogPO getPO(String docNoLogId);

    /**
     * 获取最新的文号日志
     *
     * @param docNoId
     * @param docNoUsedId
     * @return
     */
    DocNoLogPO getLatestPOByDocNoIdAndUsedId(String docNoId, String docNoUsedId);

    /**
     * 文号日志列表
     *
     * @param params
     * @return
     */
    List<DocNoLogDTO> list(Map<String, Object> params);

    /**
     * 文号日志列表
     *
     * @param params
     * @return
     */
    List<DocNoLogPO> listPO(Map<String, Object> params);

    /**
     * 文号日志分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<DocNoLogDTO>> listPage(ListPage page);

    /**
     * 文号日志统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}